Time Limit: 4000MS | Memory Limit: 65536K | |
Total Submissions: 15869 | Accepted: 7905 |
Description
Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue…
The Lunar New Year was approaching, but unluckily the Little Cat still had schedules going here and there. Now, he had to travel by train to Mianyang, Sichuan Province for the winter camp selection of the national team of Olympiad in Informatics.
It was one o’clock a.m. and dark outside. Chill wind from the northwest did not scare off the people in the queue. The cold night gave the Little Cat a shiver. Why not find a problem to think about? That was none the less better than freezing to death!
People kept jumping the queue. Since it was too dark around, such moves would not be discovered even by the people adjacent to the queue-jumpers. “If every person in the queue is assigned an integral value and all the information about those who have jumped the queue and where they stand after queue-jumping is given, can I find out the final order of people in the queue?” Thought the Little Cat.
Input
There will be several test cases in the input. Each test case consists of N + 1 lines where N (1 ≤ N ≤ 200,000) is given in the first line of the test case. The next N lines contain the pairs of values Posi and Vali in the increasing order of i (1 ≤ i ≤ N). For each i, the ranges and meanings of Posi and Vali are as follows:
- Posi ∈ [0, i − 1] — The i-th person came to the queue and stood right behind the Posi-th person in the queue. The booking office was considered the 0th person and the person at the front of the queue was considered the first person in the queue.
- Vali ∈ [0, 32767] — The i-th person was assigned the value Vali.
There no blank lines between test cases. Proceed to the end of input.
Output
For each test cases, output a single line of space-separated integers which are the values of people in the order they stand in the queue.
Sample Input
4 0 77 1 51 1 33 2 69 4 0 20523 1 19243 1 3890 0 31492
Sample Output
77 33 69 51 31492 20523 3890 19243
Hint
The figure below shows how the Little Cat found out the final order of people in the queue described in the first test case of the sample input.
线段树的思维确实很需要锻炼,这种题目刚接触时很难将之转化为线段树的思想。首先这题需要逆向推导,最后一组数据一定可以一步就对应到相应位置,而逆着往前推对计算机的时间复杂度要求会越来越高!!所以,因此在这时,我们需要用到线段树来优化求解这个问题。如何优化呢?首先构建一个线段树之后,用每个节点储存该区域内还未填满的数量,为什么要用节点存未填满的位置?首先我们输入的时候是直接告诉了应该插在哪里,而我们逆序的时候不知道前面已经插了多少了,但是我们可以对于每个子树得到一个相对位置。(这个解释起来比较麻烦,看代码再加以思考会更清楚的!!!)
这题还得注意时间复杂度!看题目给时间给了4000ms就知道得做好各种优化时间的准备了!!!!刚开始没注意用了cin超时了,改成scanf就过了。。。。
#include <iostream>
#include<stdio.h>
using namespace std;
const int N=200010;
int tree[N<<2],ans[N],num[N],p[N],v[N];
void update(int p,int v,int l,int r,int id)
{
if(l==r)
{
ans[l]=v;
tree[id]=0;//cout<<" "<<l<<' '<<v<<endl;
return;
}
// cout<<p<<' '<<v<<' '<<l<<' '<<r<<' '<<id<<' '<<tree[id]<<endl;
int m=(l+r)/2;
if(tree[id*2]>=p)
update(p,v,l,m,id*2);
else update(p-tree[id*2],v,m+1,r,id*2+1);
tree[id]=tree[id*2]+tree[id*2+1];
}
void start(int l,int r,int id)
{
if(l==r)
{
tree[id]=1;return ;
}
int m=(l+r)>>1;
start(l,m,id*2);
start(m+1,r,id*2+1);
tree[id]=tree[id*2]+tree[id*2+1];
// cout<<l<<' '<<r<<' '<<id<<' '<<tree[id]<<endl;
}
int main()
{
int n;
while(~scanf("%d",&n))
{
start(1,n,1);
for(int i=0;i<n;i++)
scanf("%d%d",&p[i],&v[i]);
for(int i=n-1;i>=0;i--)
update(p[i]+1,v[i],1,n,1);
for(int i=1;i<=n;i++)
cout<<ans[i]<<' ';
cout<<endl;
}
return 0;
}